var generate_socket = new WebSocket('ws://localhost:8888/generate');
var login_socket = new WebSocket('ws://localhost:8888/login');

var generate_endpoint = "http://localhost:8081/generate";
var register_endpoint = "http://localhost:8082/register";
var login_endpoint = "http://localhost:8082/login";

var register_form_action = "/register";
var login_form_action = "/login";

flash_error = function(err) {
	$("#error").text(err);
	$("#error").fadeIn(300).delay(2000).fadeOut(300);
}

generate = function() {
	// When the user clicks "I'm new" we send the local daemon our username
	// and ask it to generate us a password

	var username = $("#username").val();
	if (username == "") {
		flash_error("You must enter a username before you can register as a new user.");
		return;
	}
	$("#generate").prop("disabled", true);
	$("#login").prop("disabled", true);
	$("#spinner").show();
	var data = JSON.stringify({
		'username': username,
		'generate_endpoint': generate_endpoint,
		'register_endpoint': register_endpoint,
	});
	generate_socket.send(data);
}

generate_socket.onmessage = function(msg) {
	// The local daemon will respond with a password (which we put in the
	// password field, so that password managers will detect and save it) plus
	// an authentication token (which we store in a hidden attribute and is
	// what's sent to the server for actual authentication)

	$("#spinner").hide();
	$("#password_saved").fadeIn(300);
	$("#generateDiv").hide();
	$("#login").hide();
	$("#register").show();
	$("#password").prop("readonly", true);
	$("#userform").prop("action", register_form_action);
	$("#userform").prop("method", "post");

	var data = JSON.parse(msg.data);
	$("#password").val(data['password']);
	$("#authentication_token").val(data['authentication_token']);
}

login = function() {
	// When the user wants to login, we send the username and password to the
	// local daemon and ask it to initiate SRP

	var username = $("#username").val();
	var password = $("#password").val();
	if (username == "" || password == "") {
		flash_error("You must enter a username and password before you can login.");
		return false;
	}
	$("#login").prop("disabled", true);
	$("#spinner").show();
	var data = JSON.stringify({
		'username': username,
		'password': password,
		'login_endpoint': login_endpoint,
	});
	login_socket.send(data);
}

login_socket.onmessage = function(msg) {
	// The local daemon will respond with an authentication token, which we
	// store in a hidden attribute and then submit to the server

	$("#spinner").hide();

	var data = JSON.parse(msg.data);
	if (data['success'] !== true) {
		$("#login").prop("disabled", false);
		flash_error("Your password was incorrect.");
		return false;
	}

	var data = JSON.parse(msg.data);
	$("#authentication_token").val(data['authentication_token']);

	$("#userform").prop("action", login_form_action);
	$("#userform").prop("method", "post");
	$("#userform").submit();
}

$(document).ready(function() {
	$("#generate").click(generate);
	$("#login").click(login);
})
